#ifndef _SDG_VARIABLE_H_
#define _SDG_VARIABLE_H_

/* * * Sdg_Variable.h * * *
ץѿ
* * * * * * * * * * * * * */

#include"Sdg_Head.h"
#include"Sdg_Error.h"
#include"Sdg_Widget.h"

class Sdg_Script;
class Sdg_Script_Block;

//ǡμ
enum Sdg_Variable_Type{
	NO_DATA,
	NUMBER,
	STRING,
	SDG_WIDGET_POINTER,
	SCRIPT_FUNCTION,
	C_FUNCTION,
	SCRIPT_BLOCK,
};

//ץδؿΰ
struct Sdg_Script_Function{
	char *func_start; //ؿγ
	int arg_num; //ο
	Sdg_Variable_Type *arg_type; //μ
};

//ǡ
struct Sdg_Variable_Data{
	union{
	        int num;
		std::string *str;
		Sdg_Widget *wp;
		Sdg_Script_Function s_func;
		void (*c_func)(Sdg_Script *);
		Sdg_Script_Block *block;
	};
	Sdg_Variable_Type type;

	//줾Ѵؿ
	Sdg_Variable_Data():num(0),type(NO_DATA){;}
	Sdg_Variable_Data(int n):num(n),type(NUMBER){;}
	Sdg_Variable_Data(std::string s):type(STRING){str = new std::string(s);}
	Sdg_Variable_Data(Sdg_Widget *w):wp(w),type(SDG_WIDGET_POINTER){;}
	Sdg_Variable_Data(Sdg_Script_Function f):s_func(f),type(SCRIPT_FUNCTION){;}
	Sdg_Variable_Data(void (*f)(Sdg_Script *)):c_func(f),type(C_FUNCTION){;}
	Sdg_Variable_Data(Sdg_Script_Block *b):block(b),type(SCRIPT_BLOCK){;}
};

//Sdg_Varaible_Dataλ§黻
//[NUMBER|STRING] + [NUMBER|STRING]
Sdg_Variable_Data operator+(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2);
//NUMBERη׻
Sdg_Variable_Data operator-(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2);
Sdg_Variable_Data operator*(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2);
Sdg_Variable_Data operator/(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2);
Sdg_Variable_Data operator%(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2);

//ץȤǤΥǡ
class Sdg_Variable{
	//ѿ̾
	std::string name;
	//ǡ
        Sdg_Variable_Data data;

 public:
        //Ⱥ
        Sdg_Variable(const std::string &n,Sdg_Variable_Data d);
        ~Sdg_Variable();

	//ʸμ
	const std::string& Name(void) const{return name;}
	//ʸ
	void SetName(std::string &n){name = n;}
	//ǡμ
	const Sdg_Variable_Data Data(void) const{return data;}
	//ǡ
	void SetData(Sdg_Variable_Data &d){data = d;}
};

//ɽ
std::ostream &operator<<(std::ostream &o,const Sdg_Variable &v);

class Sdg_List;
//֥å({,}ǰϤޤ줿ʬ)
class Sdg_Script_Block{
 public:
	//
	//ϰľΥ֥å
	Sdg_Script_Block(Sdg_Script_Block *p);
	~Sdg_Script_Block();

	//ꥹѴؿ
	//ǡ
	//var_list򸡺ơʤprevõ
	Sdg_Variable *Search(std::string &name);
	//ǡϿ
	void Add(Sdg_Variable &d);
	//
	void Remove(std::string &name);

	//ؿ¹Ԥ
	//var_list򸡺ơʤprevõ
	void Call(std::string &name);
 private:
	Sdg_List *var_list;
	Sdg_Script_Block *prev; //Υ֥å
};

//ץȤν
void Sdg_Script_Init(void);

//yyparseǤĤѿ
struct yyparse_type{
	Sdg_Variable_Data var;
	char identify[256];
};


#endif /*_SDG_VARIABLE_H_*/
