%{
/* * * Sdg_Lex.l * * *
ϴؿ
* * * * * * * * * * */

#include"Sdg_Head.h"
#include"Sdg_Error.h"
#include"Sdg_Variable.h"

void yyerror(char *msg);

#define YY_SKIP_YYWRAP
int yywrap(void){return 1;}

#undef YYSTYPE
#define YYSTYPE yyparse_type

/*yaccΥǡ*/
#include"Sdg_Yacc.tab.h"

//ϥǡ
sdg_u8 *script_data;

//ʸ
static char str[1024];
//ʸΥ
static size_t str_num;
//ʸؿ
static void getword(char *src,char *dst,size_t s);

//ѹ
#undef YY_INPUT
#define YY_INPUT(buffer,result,max_size) \
	{\
		buffer[0] = *script_data;\
		if(*script_data == '\0') \
			result = YY_NULL;\
		else\
			result = 1;\
		script_data++;\
	}

%}

NUMBER	[0-9]
CHAR	[A-Za-z_]

%x COMMENT STRING

%%

"#"		{//Ƚ
		BEGIN(COMMENT);}
<COMMENT>[^\n]* 
<COMMENT>\n	{BEGIN(INITIAL);}

{NUMBER}+	{//
		yylval.var = atol(yytext); 
		return Y_NUMBER;}

{CHAR}({NUMBER}|{CHAR})* {//̻ҽ
		getword(yytext,yylval.identify,sizeof yylval.identify);
		return Y_IDENTIFY;}

\"		{//ʸ
		str_num = 0; BEGIN(STRING);}

<STRING>\"	{str[str_num] = '\0'; 
		yylval.var = Sdg_Variable_Data(str);
		BEGIN(INITIAL);
		return Y_STRING;}

<STRING>.	{str[str_num++] = yytext[0];}

.		return yytext[0];

%%

/*̾ȴ*/
static void getword(char *src,char *dst,size_t s)
{
        char *end = dst + s;

        while(isspace(*src)) src++;
        while((isalnum(*src) || *src == '_') && dst < end)
                *dst++ = *src++;
        *dst = '\0';
        return;
}

