/* * * Sdg_Variable.cpp * * *
Sdg_ScriptѤѿ
* * * * * * * * * * * * * * */

#include"Sdg_Variable.h"
#include"Sdg_List.h"

using namespace std;
/*----- ѿ -----*/
/* * * ѿκ * * */
Sdg_Variable::Sdg_Variable(const string &n,Sdg_Variable_Data d)
	: name(n),  data(d)
{
}

/* * *  * * */
Sdg_Variable::~Sdg_Variable()
{
}

/*----- Sdg_Variableλ§黻 -----*/

/* * * intstringѴ * * */
static string itos(int num)
{
	char str[128];
	char *s = str;
	int i,sign;

	if((sign = num) < 0)
		num = -num;
	i = 0;
	do{
		*s++ = num % 10 + '0';
	}while((num /= 10) > 0);
	if(sign < 0)
		*s++ = '-';
	//¤Ӥ촹
	char *t = str,*q = s-1;
	char c;
	for(; t < q; t++,q--){
		c = *t;
		*t = *q;
		*q = c;
	}
	*s = '\0';
	return string(s);
}

/*----- §黻 -----*/

/* * * Sdg_Variable_DatastringѴ * * */
static string Sdg_Variable_Data_To_Str(const Sdg_Variable_Data &v)
{
	switch(v.type){
	case NO_DATA:
		return "<NO_DATA>";
	case NUMBER:
		return itos(v.num);
	case STRING:
		return *v.str;
	case SDG_WIDGET_POINTER:
		return "<Sdg_Widget *>";
	case SCRIPT_FUNCTION:
		return "<Function>";
	case C_FUNCTION:
		return "<C code function>";
	case SCRIPT_BLOCK:
		return "<Block>";
	default:
		return "<Undefined type>";
	}
}

/* * * ­(NUMBER or STRING) * * */
Sdg_Variable_Data operator+(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2)
{
	//ɤ
	if(v1.type == NUMBER && v2.type == NUMBER)
		return Sdg_Variable_Data(v1.num+v2.num);
	//ʸ󤬺
	else if(v1.type == STRING || v2.type == STRING)
		return Sdg_Variable_Data(Sdg_Variable_Data_To_Str(v1)
					 +Sdg_Variable_Data_To_Str(v2));
	//¾
	else
		throw Sdg_Error::ScriptOperationError("Invalid type (plus error)");
}

/*---- Ͽ ----*/
/* * *  * * */
Sdg_Variable_Data operator-(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2)
{
	if(v1.type != NUMBER || v2.type != NUMBER)
		throw Sdg_Error::ScriptOperationError("Invalid type (minus error)");
	return Sdg_Variable_Data(v1.num-v2.num);
}

/* * *  * * */
Sdg_Variable_Data operator*(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2)
{
	if(v1.type != NUMBER || v2.type != NUMBER)
		throw Sdg_Error::ScriptOperationError(
			"Invalid type (multiplication error)");
	return Sdg_Variable_Data(v1.num*v2.num);
}

/* * * 任 * * */
Sdg_Variable_Data operator/(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2)
{
	if(v1.type != NUMBER || v2.type != NUMBER)
		throw Sdg_Error::ScriptOperationError(
			"Invalid type (division error)");
	if(v2.num == 0)
		throw Sdg_Error::ScriptOperationError("Zero division error");
	return Sdg_Variable_Data(v1.num/v2.num);
}

/* * * ; * * */
Sdg_Variable_Data operator%(const Sdg_Variable_Data &v1,const Sdg_Variable_Data &v2)
{
	if(v1.type != NUMBER || v2.type != NUMBER)
		throw Sdg_Error::ScriptOperationError(
			"Invalid type (surplus error)");
	if(v2.num == 0)
		throw Sdg_Error::ScriptOperationError("Zero surplus error");
	return Sdg_Variable_Data(v1.num%v2.num);
}

/* * * ɽ * * */
std::ostream &operator<<(ostream &o,const Sdg_Variable &v)
{
	switch(v.Data().type){
	case NO_DATA:
		o << v.Name() << "=" << "NO_DATA" << endl;
		break;
	case NUMBER:
		o << v.Name() << "=" << v.Data().num << endl;
		break;
	case STRING:
		o << v.Name() << "=" << *v.Data().str << endl;
		break;
	case SDG_WIDGET_POINTER:
		o << v.Name() << "=" << "Sdg_Widget pointer" << endl;
		break;
	case SCRIPT_FUNCTION:
		o << v.Name() << "=" << "Script function" << endl;
		break;
	case C_FUNCTION:
		o << v.Name() << "=" << "C function for Script" << endl;
		break;
	case SCRIPT_BLOCK:
		o << v.Name() << "=" << "Script block" << endl;
		break;
	default:
		o << v.Name() << "=" << "Undefined variable" << endl;
		break;
	}
	return o;
}

/*----- ץȤΥ֥å -----*/
/* * *  * * */
Sdg_Script_Block::Sdg_Script_Block(Sdg_Script_Block *p)
	:prev(p)
{
	/*ꥹȤκ*/
	var_list = new Sdg_List;
	/*ɬפѿ*/
}

/* * *  * * */
Sdg_Variable *Sdg_Script_Block::Search(std::string &name)
{
	Sdg_Variable *v;

	v = var_list->Search(name);
	if(v == NULL && prev != NULL)
		v = prev->Search(name);
	return v;
}

/* * * ɲ * * */
void Sdg_Script_Block::Add(Sdg_Variable &d)
{
	var_list->Add(d);
}

/* * * ѿκ * * */
void Sdg_Script_Block::Remove(string &name)
{
	var_list->Remove(name);
}

/* * *  * * */
Sdg_Script_Block::~Sdg_Script_Block()
{
	/*ꥹȤκ*/
	delete var_list;
}
