/* * * Sdg_Widget.cpp * * *
Sdg_Widget饹μ
* * * * * * * * * * * * * */
#include"Sdg_Error.h"
#include"Sdg_Widget.h"
#include"Extern.h"

/*----- Υ饹 -----*/
/* * * 饹ν,pixelꤹ * * */
Sdg_Color::Sdg_Color(sdg_u8 red,sdg_u8 green,sdg_u8 blue)
	:r(red),g(green),b(blue)
{
	XColor c;
	c.red = r*256;
	c.green = g*256;
	c.blue = b*256;
	//pixelμ
	if(XAllocColor(display,colormap,&c) == 0) //顼
		throw Sdg_Error::X11OnlyError("XAllocColor failed.");
	pixel = c.pixel;
}

/*----- ٥Ѵؿ -----*/
/* * * SdgΥ٥ȥޥX11ѤѴ * * */
static long sdg_mask_to_x11(sdg_u32 mask)
{
	/*٥ȥޥ*/
	/*mask_list[եȿ] X11ѤΥޥФ*/
	const long mask_list[] = {
		NoEventMask, /*SDG_NO_EVENT*/
		KeyPressMask, /*SDG_KEY_PRESS*/
		KeyReleaseMask, /*SDG_KEY_RELEASE*/
		ButtonPressMask, /*SDG_BUTTON_PRESS*/
		ButtonReleaseMask, /*SDG_BUTTON_RELEASE*/
		ExposureMask, /*SDG_REPAINT*/
		StructureNotifyMask, /*SDG_DESTROY*/
	};
	const int mask_num = sizeof mask_list / sizeof mask_list[0];
	int shift_num;

	/*եȿ*/
	for(shift_num=0; (mask >> shift_num) != 1; shift_num++)
		if(!(shift_num < mask_num)) break;
	if(shift_num >= mask_num)
		return mask_list[0];
	return mask_list[shift_num];
}

/*----- åȤδܤΥ饹 -----*/
/* * * åȤκ * * */
Sdg_Widget::Sdg_Widget(Sdg_Widget *parent, //ƥå(ʤʤNULL)
		       sdg_u16 x,sdg_u16 y, //ɽɸ
		       sdg_u16 width,sdg_u16 height, //
		       sdg_u32 mask) //٥ȥޥ
{
	Window root;
	sdg_u32 border_color,back_ground;
	//Ƥ
	if(parent == NULL)
		root = root_window;
	else
		root = parent->sys->wid;
	//¸ѿκ
	sys = new Sdg_Sys_Widget;
	//μ
	border_color = BlackPixel(display,0);
	back_ground = WhitePixel(display,0);
	//ɥκ
	sys->wid = XCreateSimpleWindow(display,root,x,y,width,height,0,
				       border_color,back_ground);
	//٥Ȥ
	XSelectInput(display,sys->wid,sdg_mask_to_x11(mask));
	//ѿ
	this->parent = parent;
	event_mask = mask;
}

/* * * åȤκ * * */
Sdg_Widget::~Sdg_Widget()
{
	//ɥκ
	XDestroyWindow(display,sys->wid);
	delete sys;
}

/* * * ɽ * * */
void Sdg_Widget::Map(void)
{
	XEvent e;

	XSelectInput(display,sys->wid,ExposureMask);
	XMapWindow(display,sys->wid);
	//ɽޤԤ
	do{
		XNextEvent(display,&e);
	}while(e.type != Expose);
}

/* * *  * * */
void Sdg_Widget::Unmap(void)
{
	XUnmapWindow(display,sys->wid);
}

/* * * ѹ * * */
/* 0ξѹʤ */
void Sdg_Widget::Resize(sdg_u16 x,sdg_u16 y,sdg_u16 width,sdg_u16 height)
{
	//0ξ
	if(x==0 || y==0 || width==0 || height==0){
		unsigned int dummy;
		int *px,*py;
		unsigned int *pwidth,*pheight;

		/*ϥ㥹Ȥ¿Ƥߤˤ*/
		(unsigned int*)px = (unsigned int*)py = pwidth = pheight = &dummy;
		if(x == 0) px = (int*)&x;
		if(y == 0) py = (int*)&y;
		if(width == 0) pwidth = (unsigned int*)&width;
		if(height == 0) pheight = (unsigned int*)&height;
		XGetGeometry(display,sys->wid,(Window*)&dummy,px,py,pwidth,pheight,
			     &dummy,&dummy);
	}
	//()ѹ
	XMoveResizeWindow(display,sys->wid,x,y,width,height);
}

/* * * ٥Ȥɲä * * */
void Sdg_Widget::AddEvent(sdg_u32 mask)
{
	XSelectInput(display,sys->wid,sdg_mask_to_x11(mask));
}

/* * * ΥåȤκ * * */
Sdg_Widget::Sdg_Widget()
{
	sys = new Sdg_Sys_Widget;
}
